//
// practica0.c - creacion y visualizacion de una imagen usando OpenCV
//
// Robotica y Vision por Computador

#include "cv.h" // incluye las definiciones de OpenCV
#include "cvaux.h" // Stuff. 
#include "highgui.h" // incluye highGUI. Necesario para crear ventanas de visualizacion
#include <stdio.h>


int main()
{
	IplImage *cvImg; // estructura IplImage para crear y manejar imagenes
	CvSize imgSize; // tamanyo de la imagen
	
	int i = 0, j = 0;
	imgSize.width = 640; // el tamao de la imagen es
	imgSize.height = 480; // 640x480 pixels
	
	// se crea una imagen de grises con 8 bits de profundidad
	cvImg = cvCreateImage( imgSize, 8, 1 );
	
	// para recorrer la imagen, se utiliza un bucle anidado
	// y el acceso al pixel se realiza al igual que para 
	// cualquier array unidimensional
	for ( i = 0; i < imgSize.width; i++ )
		for ( j = 0; j < imgSize.height; j++ )
		((uchar*)(cvImg->imageData + cvImg->widthStep*j))[i] =(char) ( ( i * j ) % 256 );
	
	cvNamedWindow( "RVC. probando OpenCV...", 1 ); // se crea la ventana de visualizacion
	cvShowImage( "RVC. probando OpenCV...", cvImg ); // se visualiza la imagen en dicha ventana
	
	cvWaitKey( 0 ); // espera la pulsacion de la tecla
	cvDestroyWindow( "image" ); // se cierra la ventana de visualizacion
	cvReleaseImage( &cvImg ); // se libera la memoria
	
	return( 0 );
}